<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGuaranteeTypeGuaranteeAccepted ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfGuaranteeTypeGuaranteeAccepted extends AbstractStructArrayBase
{
    /**
     * The GuaranteeAccepted
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgGuaranteeAccepted[]
     */
    public $GuaranteeAccepted;
    /**
     * Constructor method for ArrayOfGuaranteeTypeGuaranteeAccepted
     * @uses DgArrayOfGuaranteeTypeGuaranteeAccepted::setGuaranteeAccepted()
     * @param \dgsoft\StructType\DgGuaranteeAccepted[] $guaranteeAccepted
     */
    public function __construct(array $guaranteeAccepted = array())
    {
        $this
            ->setGuaranteeAccepted($guaranteeAccepted);
    }
    /**
     * Get GuaranteeAccepted value
     * @return \dgsoft\StructType\DgGuaranteeAccepted[]|null
     */
    public function getGuaranteeAccepted()
    {
        return $this->GuaranteeAccepted;
    }
    /**
     * Set GuaranteeAccepted value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgGuaranteeAccepted[] $guaranteeAccepted
     * @return \dgsoft\ArrayType\DgArrayOfGuaranteeTypeGuaranteeAccepted
     */
    public function setGuaranteeAccepted(array $guaranteeAccepted = array())
    {
        foreach ($guaranteeAccepted as $arrayOfGuaranteeTypeGuaranteeAcceptedGuaranteeAcceptedItem) {
            // validation for constraint: itemType
            if (!$arrayOfGuaranteeTypeGuaranteeAcceptedGuaranteeAcceptedItem instanceof \dgsoft\StructType\DgGuaranteeAccepted) {
                throw new \InvalidArgumentException(sprintf('The GuaranteeAccepted property can only contain items of \dgsoft\StructType\DgGuaranteeAccepted, "%s" given', is_object($arrayOfGuaranteeTypeGuaranteeAcceptedGuaranteeAcceptedItem) ? get_class($arrayOfGuaranteeTypeGuaranteeAcceptedGuaranteeAcceptedItem) : gettype($arrayOfGuaranteeTypeGuaranteeAcceptedGuaranteeAcceptedItem)), __LINE__);
            }
        }
        $this->GuaranteeAccepted = $guaranteeAccepted;
        return $this;
    }
    /**
     * Add item to GuaranteeAccepted value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgGuaranteeAccepted $item
     * @return \dgsoft\ArrayType\DgArrayOfGuaranteeTypeGuaranteeAccepted
     */
    public function addToGuaranteeAccepted(\dgsoft\StructType\DgGuaranteeAccepted $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgGuaranteeAccepted) {
            throw new \InvalidArgumentException(sprintf('The GuaranteeAccepted property can only contain items of \dgsoft\StructType\DgGuaranteeAccepted, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->GuaranteeAccepted[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgGuaranteeAccepted|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgGuaranteeAccepted|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgGuaranteeAccepted|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgGuaranteeAccepted|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgGuaranteeAccepted|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GuaranteeAccepted
     */
    public function getAttributeName()
    {
        return 'GuaranteeAccepted';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfGuaranteeTypeGuaranteeAccepted
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
